service: ebased
frameworkVersion: '3'

plugins:
  - serverless-iam-roles-per-function

provider:
  name: aws
  runtime: nodejs12.x
  region: us-east-1
  stage: dev

functions:

  createClient: 
    name: createClient
    handler: create-client/handler/create-client.handler
    environment:
      CREATE_CLIENT_TABLE: !Ref CreateClientTable
    iamRoleStatementsInherit: true
    iamRoleStatements: 
      - Effect: Allow
        Action:
          - dynamodb:PutItem
        Resource:
          - !GetAtt CreateClientTable.Arn
    events:
      - http:
          path: client
          method: POST

resources:
  Resources:
    CreateClientTable:
      Type: 'AWS::DynamoDB::Table'
      DeletionPolicy: Retain
      Properties:
        AttributeDefinitions:
          -
            AttributeName: "id"
            AttributeType: "S"   
        KeySchema:
          -
            AttributeName: "id"
            KeyType: "HASH"
        ProvisionedThroughput:
          ReadCapacityUnits: 1
          WriteCapacityUnits: 1
        StreamSpecification:
          StreamViewType: "NEW_AND_OLD_IMAGES"
        TableName: ${self:service}-${self:provider.stage}-CreateClientTable
